#include "basin_base.h"
#include "Attribute.h"



bool Attribute::set_name_from_parent (string name) {
	attribute_name = name;
	return true;
}

Attribute attribute_random(vector<int> nd,unsigned int seed)
{
      Attribute temp;
      bv_stlvec tempvec=nd;
      bv3 local_seed=seed;

      int ndims=nd.size(); 
      vector<double> ll(ndims,0.),ur(ndims,0.);
      vector<int> nx(nd);

      for (int i=0; i < ndims; i++) 
	{
	  ur[i]=nx[i]-1;
	}

      Context* c=new Context(ll,ur,nx,NULL);
      temp.set_attribute(boost::apply_visitor(Attribute_random_visitor(),tempvec,local_seed));
      temp.set_context(c);
      return temp;
}

Attribute attribute_random(int nd,unsigned int seed)
{
      Attribute temp;
      bv2 nr=nd;
      bv3 local_seed=seed;
      int ndims=1; 
      vector<double> ll(ndims,0.),ur(ndims,nd-1);
      vector<int> nx(ndims,nd);
      Context* c=new Context(ll,ur,nx,NULL);
      temp.set_attribute(boost::apply_visitor(Attribute_random_visitor(),nr,local_seed));
      temp.set_context(c);
      return temp;
}


 

//------------
Attribute where(const Attribute& b,const Attribute& h,const Attribute& j)
{
  //  Attribute temp;
  bv b_data;
  b.get_data(b_data);
  bv h_data;
  h.get_data(h_data);
  bv j_data;
  j.get_data(j_data);
  bv temp1;
  if (ba<int> *p=boost::get<ba<int> >(&b_data))
    {
      if(h_data.which()==j_data.which())
	{
	  if (ba<int> *p1=boost::get<ba<int> >(&h_data))
	    {
	      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<int> >(h_data),boost::get<ba<int> >(j_data));
	    }
#ifdef VECTOR23
	  else if (ba<Vector3> *p1=boost::get<ba<Vector3> >(&h_data))
	    {
	      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<Vector3> >(h_data),boost::get<ba<Vector3> >(j_data));
	    }
	  else if (ba<Vector2> *p1=boost::get<ba<Vector2> >(&h_data))
	    {
	      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<Vector2> >(h_data),boost::get<ba<Vector2> >(j_data));
	    }
#endif
	  else if (ba<fftw_complex> *p1=boost::get<ba<fftw_complex> >(&h_data))
	    {
	      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<fftw_complex> >(h_data),boost::get<ba<fftw_complex> >(j_data));
	    }
	  else if (ba<char> *p1=boost::get<ba<char> >(&h_data))
	    {
	      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<char> >(h_data),boost::get<ba<char> >(j_data));
	    }
	  else if (ba<float> *p1=boost::get<ba<float> >(&h_data))
	    {
	      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<float> >(h_data),boost::get<ba<float> >(j_data));
	    }
	  else if (ba<double> *p1=boost::get<ba<double> >(&h_data))
	    {
	      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<double> >(h_data),boost::get<ba<double> >(j_data));
	    }
	  else
	    {
	      cerr<<"ERROR:Type of second and third arguments in the where function not found-Empty attribute returned"<<endl;
	      return Attribute();
	    }
	}
      else 
	{
	  cerr<<"ERROR:the type of the second and the third argument are not equal.Empty Attribute returned"<<endl;
	  return Attribute();
	}
    }
  else 
    {
      cerr<<"ERROR:first argument of where function is not a relational operator.Empty Attribute returned"<<endl;
      return Attribute();
    }
  return Attribute(temp1,h.get_context_pointer());
}


//**************************************************************
//  This will return an Attribute possibly shorter than the original


//------------
Attribute where(const Attribute& b1,Attribute& h)
{
  
  Attribute dum=where(b1,h,0);
  Attribute b=b1;
  int final_elements=sum(b);
  int lo,hi;
  int BASIN_ID, BASIN_NPROCS;
  MPI_Comm_rank(BASIN_COMM,&BASIN_ID);
  MPI_Comm_size(BASIN_COMM,&BASIN_NPROCS); 

  h.get_gen_distribution(BASIN_ID,&lo,&hi);
  if (h.get_data_type() == BASIN_DATA_DOUBLE) 
    {
      Attribute attr_out(final_elements,double(0.));
      double olddat[hi-lo+1];
      vector<double> newdat;
      h.get(lo,hi,olddat);
      int n=0;
      for (int i=0; i < hi-lo+1; i++) 
	{
	  if (int(b[lo+i]) != 0) {
	    newdat.push_back(olddat[i]);
	    n=n+1;
	  }
	}
      int n1=0;
      MPI_Status status;
      if (BASIN_NPROCS==1) { n1=0;}
      else if (BASIN_ID == 0) 
	{
	  MPI_Send(&n,1,MPI_INT,1,0,BASIN_COMM);
	} 
      else if (BASIN_ID == BASIN_NPROCS-1)
	{
	  MPI_Recv(&n1,1,MPI_INT,BASIN_NPROCS-2,0,BASIN_COMM,&status);
	} 
      else 
	{
	  MPI_Recv(&n1,1,MPI_INT,BASIN_ID-1,0,BASIN_COMM,&status);
	  n=n+n1;
	  MPI_Send(&n,1,MPI_INT,BASIN_ID+1,0,BASIN_COMM);
	}
      if (newdat.size() > 0) 
	{
	  attr_out.put(n1,n1+newdat.size()-1,newdat);    
	}

      int ndims=1; 
      vector<double> ll(ndims,0.),ur(ndims,final_elements-1);
      vector<int> nx(ndims,final_elements);
      Context* c=new Context(ll,ur,nx,NULL);
      attr_out.set_context(c);

      return attr_out;
    }
}
//********************************************************************



Attribute where(const Attribute& b,const double& h_data,const Attribute& j)
{
  bv b_data;
  b.get_data(b_data);
  bv j_data;
  j.get_data(j_data);
  bv temp1;
  if (ba<double> *p1=boost::get<ba<double> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),h_data,boost::get<ba<double> >(j_data));
      return Attribute(temp1,j.get_context_pointer());
    }
  else if (ba<float> *p1=boost::get<ba<float> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),(float)h_data,boost::get<ba<float> >(j_data));
      return Attribute(temp1,j.get_context_pointer());
    }
  else
    {
      cerr<<"ERROR:Type mismatch, the type of the second argument in the where function is different from the type of the third argument. Empty Attribute retunred "<<endl;
      return Attribute();
    }
}

Attribute where(const Attribute& b,const float& h_data,const Attribute& j)
{
  bv b_data;
  b.get_data(b_data);
  bv j_data;
  j.get_data(j_data);
  bv temp1;
  if (ba<float> *p1=boost::get<ba<float> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),h_data,boost::get<ba<float> >(j_data));
      return Attribute(temp1,j.get_context_pointer());
    }
  else if (ba<double> *p1=boost::get<ba<double> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),(double)h_data,boost::get<ba<double> >(j_data));
      return Attribute(temp1,j.get_context_pointer());
    }
  else
    {
      cerr<<"ERROR:Type mismatch, the type of the second argument in the where function is different from the type of the third argument. Empty Attribute retunred "<<endl;
      return Attribute();
    }
}

Attribute where(const Attribute& b,const int& h_data,const Attribute& j)
{
  bv b_data;
  b.get_data(b_data);
  bv j_data;
  j.get_data(j_data);
  bv temp1;
  if (ba<int> *p1=boost::get<ba<int> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),h_data,boost::get<ba<int> >(j_data));

      return Attribute(temp1,j.get_context_pointer());
    }
  else if (ba<float> *p1=boost::get<ba<float> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),(float)h_data,boost::get<ba<float> >(j_data));
      return Attribute(temp1,j.get_context_pointer());
    }
  else if (ba<double> *p1=boost::get<ba<double> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),(double)h_data,boost::get<ba<double> >(j_data));
      return Attribute(temp1,j.get_context_pointer());
    }
  else
    {
      cerr<<"ERROR:Type mismatch, the type of the second argument in the where function is different from the type of the third argument. Empty Attribute retunred "<<endl;
      return Attribute();
    }
}

Attribute where(const Attribute& b,const fftw_complex& h_data,const Attribute& j)
{
  bv b_data;
  b.get_data(b_data);
  bv j_data;
  j.get_data(j_data);
  bv temp1;
  if (ba<fftw_complex> *p1=boost::get<ba<fftw_complex> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),h_data,boost::get<ba<fftw_complex> >(j_data));
      return Attribute(temp1,j.get_context_pointer());
    }
  else
    {
      cerr<<"ERROR:Type mismatch, the type of the second argument in the where function is different from the type of the third argument. Empty Attribute retunred "<<endl;
      return Attribute();
    }
}

#ifdef VECTOR23
Attribute where(const Attribute& b,const Vector3& h_data,const Attribute& j)
{
  bv b_data;
  b.get_data(b_data);
  bv j_data;
  j.get_data(j_data);
  bv temp1;
  if (ba<Vector3> *p1=boost::get<ba<Vector3> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),h_data,boost::get<ba<Vector3> >(j_data));
      return Attribute(temp1,j.get_context_pointer());
    }
  else
    {
      cerr<<"ERROR:Type mismatch, the type of the second argument in the where function is different from the type of the third argument. Empty Attribute retunred "<<endl;
      return Attribute();
    }
}

Attribute where(const Attribute& b,const Vector2& h_data,const Attribute& j)
{
  bv b_data;
  b.get_data(b_data);
  bv j_data;
  j.get_data(j_data);
  bv temp1;
  if (ba<Vector2> *p1=boost::get<ba<Vector2> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),h_data,boost::get<ba<Vector2> >(j_data));
      return Attribute(temp1,j.get_context_pointer());
    }
  else
    {
      cerr<<"ERROR:Type mismatch, the type of the second argument in the where function is different from the type of the third argument. Empty Attribute retunred "<<endl;
      return Attribute();
    }
}
#endif

Attribute where(const Attribute& b,const char& h_data,const Attribute& j)
{
  bv b_data;
  b.get_data(b_data);
  bv j_data;
  j.get_data(j_data);
  bv temp1;
  if (ba<char> *p1=boost::get<ba<char> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),h_data,boost::get<ba<char> >(j_data));
      return Attribute(temp1,j.get_context_pointer());
    }
  else
    {
      cerr<<"ERROR:Type mismatch, the type of the second argument in the where function is different from the type of the third argument. Empty Attribute retunred "<<endl;
      return Attribute();
    }
}


Attribute where(const Attribute& b,const Attribute& j,const double & h_data)
{
  bv b_data;
  b.get_data(b_data);
  bv j_data;
  j.get_data(j_data);
  bv temp1;
  if (ba<double> *p1=boost::get<ba<double> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<double> >(j_data),h_data);
      return Attribute(temp1,j.get_context_pointer());
    }
  else if (ba<float> *p1=boost::get<ba<float> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<float> >(j_data),(float)h_data);
      return Attribute(temp1,j.get_context_pointer());
    }
  else
    {
      cerr<<"ERROR:Type mismatch, the type of the second argument in the where function is different from the type of the third argument. Empty Attribute returned "<<endl;
      return Attribute();
    }
}

Attribute where(const Attribute& b,const Attribute& j,const float & h_data)
{
  bv b_data;
  b.get_data(b_data);
  bv j_data;
  j.get_data(j_data);
  bv temp1;
  if (ba<float> *p1=boost::get<ba<float> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<float> >(j_data),h_data);
      return Attribute(temp1,j.get_context_pointer());
    }
  else if (ba<double> *p1=boost::get<ba<double> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<double> >(j_data),(double)h_data);
      return Attribute(temp1,j.get_context_pointer());
    }
  else
    {
      cerr<<"ERROR:Type mismatch, the type of the second argument in the where function is different from the type of the third argument. Empty Attribute returned "<<endl;
      return Attribute();
    }
}

Attribute where(const Attribute& b,const Attribute& j,const int & h_data)
{
  bv b_data;
  b.get_data(b_data);
  bv j_data;
  j.get_data(j_data);
  bv temp1;
  if (ba<int> *p1=boost::get<ba<int> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<int> >(j_data),h_data);
      return Attribute(temp1,j.get_context_pointer());
    }
  else if (ba<double> *p1=boost::get<ba<double> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<double> >(j_data),(double)h_data);
      return Attribute(temp1,j.get_context_pointer());
    }
  else if (ba<float> *p1=boost::get<ba<float> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<float> >(j_data),(float)h_data);
      return Attribute(temp1,j.get_context_pointer());
    }
  else
    {
      cerr<<"ERROR:Type mismatch, the type of the second argument in the where function is different from the type of the third argument. Empty Attribute returned "<<endl;
      return Attribute();
    }
}

Attribute where(const Attribute& b,const Attribute& j,const fftw_complex & h_data)
{
  bv b_data;
  b.get_data(b_data);
  bv j_data;
  j.get_data(j_data);
  bv temp1;
  if (ba<fftw_complex> *p1=boost::get<ba<fftw_complex> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<fftw_complex> >(j_data),h_data);
      return Attribute(temp1,j.get_context_pointer());
    }
  else
    {
      cerr<<"ERROR:Type mismatch, the type of the second argument in the where function is different from the type of the third argument. Empty Attribute returned "<<endl;
      return Attribute();
    }
}


#ifdef VECTOR23
Attribute where(const Attribute& b,const Attribute& j,const Vector3 & h_data)
{
  bv b_data;
  b.get_data(b_data);
  bv j_data;
  j.get_data(j_data);
  bv temp1;
  if (ba<Vector3> *p1=boost::get<ba<Vector3> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<Vector3> >(j_data),h_data);
      return Attribute(temp1,j.get_context_pointer());
    }
  else
    {
      cerr<<"ERROR:Type mismatch, the type of the second argument in the where function is different from the type of the third argument. Empty Attribute returned "<<endl;
      return Attribute();
    }
}

Attribute where(const Attribute& b,const Attribute& j,const Vector2 & h_data)
{
  bv b_data;
  b.get_data(b_data);
  bv j_data;
  j.get_data(j_data);
  bv temp1;
  if (ba<Vector2> *p1=boost::get<ba<Vector2> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<Vector2> >(j_data),h_data);
      return Attribute(temp1,j.get_context_pointer());
    }
  else
    {
      cerr<<"ERROR:Type mismatch, the type of the second argument in the where function is different from the type of the third argument. Empty Attribute returned "<<endl;
      return Attribute();
    }
}
#endif

Attribute where(const Attribute& b,const Attribute& j,const char & h_data)
{
  bv b_data;
  b.get_data(b_data);
  bv j_data;
  j.get_data(j_data);
  bv temp1;
  if (ba<char> *p1=boost::get<ba<char> >(&j_data))
    {
      temp1=ba_where(boost::get<ba<int> >(b_data),boost::get<ba<char> >(j_data),h_data);
      return Attribute(temp1,j.get_context_pointer());
    }
  else
    {
      cerr<<"ERROR:Type mismatch, the type of the second argument in the where function is different from the type of the third argument. Empty Attribute returned "<<endl;
      return Attribute();
    }
}



Attribute where(const Attribute& b,const int& j,const int & h_data)
{
  bv b_data;
  b.get_data(b_data);
  bv temp1;
  temp1=ba_where(boost::get<ba<int> >(b_data),j,h_data);
  return Attribute(temp1,b.get_context_pointer());
}


Attribute where(const Attribute& b,const float& j,const float & h_data)
{
  bv b_data;
  b.get_data(b_data);
  bv temp1;
  temp1=ba_where(boost::get<ba<int> >(b_data),j,h_data);

  return Attribute(temp1,b.get_context_pointer());
}


Attribute where(const Attribute& b,const double& j,const double & h_data)
{
  bv b_data;
  b.get_data(b_data);
  bv temp1;
  temp1=ba_where(boost::get<ba<int> >(b_data),j,h_data);
  return Attribute(temp1,b.get_context_pointer());
}




//-----------------
Attribute exp(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_exp_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }


Attribute pow(const Attribute& b,double z)
{
  //  Attribute temp;
      bv b_data;
      bv_pod bv_index=z;
      b.get_data(b_data);
      //  temp.set_attribute(boost::apply_visitor(Attribute_pow_visitor(),b_data,bv_index));
      return Attribute(boost::apply_visitor(Attribute_pow_visitor(),b_data,bv_index),b.get_context_pointer());
	  
}

Attribute pow(const Attribute& b,fftw_complex z)
{
  //  Attribute temp;
      bv b_data;
      bv_pod bv_index=z;
      b.get_data(b_data);
      //  temp.set_attribute(boost::apply_visitor(Attribute_pow_visitor(),b_data,bv_index));
      return Attribute(boost::apply_visitor(Attribute_pow_visitor(),b_data,bv_index)  ,b.get_context_pointer());
    }


Attribute log(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_log_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }

Attribute real(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_real_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }

Attribute imag(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_imag_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }


Attribute log10(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_log10_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }


Attribute sin(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_sin_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }


Attribute cos(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_cos_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }


Attribute cosh(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_cosh_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }

Attribute sinh(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_sinh_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }

Attribute asin(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_asin_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }


Attribute acos(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_acos_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }
Attribute acosh(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_acosh_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }
Attribute asinh(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_asinh_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }


Attribute abs(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_abs_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }

Attribute sqrt(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_sqrt_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }



Attribute exp10(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_exp10_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }
Attribute atan(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_atan_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }


Attribute sort(const Attribute& b)
{
      Attribute temp;
      bv b_data;
      b.get_data(b_data);
      temp.set_attribute(boost::apply_visitor(Attribute_sortA_visitor(),b_data));
      temp.set_context(b.get_context_pointer());
      return temp;
    }



Attribute index_sort(const Attribute& b)
{
  Attribute temp;
  bv b_data;
  b.get_data(b_data);
  temp.set_attribute(boost::apply_visitor(Attribute_indexSorted_visitor(),b_data));
  temp.set_context(b.get_context_pointer());
  return temp;
}


Attribute conj(Attribute &attr) {
  int iLo,iHi;
  Attribute_Data_Type type;
  int basin_id,basin_nprocs;
  MPI_Comm_size(MPI_COMM_WORLD,&basin_nprocs); 
  MPI_Comm_rank(MPI_COMM_WORLD,&basin_id);

  attr.get_gen_distribution_index(basin_id, &iLo, &iHi);
  type=attr.get_data_type();
  if (type == BASIN_DATA_COMPLEX) {
    fftw_complex* mydat=new fftw_complex[iHi-iLo+1];
    attr.get(iLo,iHi,mydat);
    Attribute attr_out(attr);
    for (int i=0 ; i < iHi-iLo+1; i++) {
      mydat[i].im=-mydat[i].im;
    }
    attr_out.put(iLo,iHi,mydat);
    free(mydat);
    return attr_out;
  } else {
    //Attribute dum=attr;
    return(attr); 
  }
}

Attribute fix(const Attribute& attr) {
  int iLo,iHi;
  Attribute dum=attr;
  int BASIN_ID, BASIN_NPROCS;
  MPI_Comm_rank(BASIN_COMM,&BASIN_ID);
  MPI_Comm_size(BASIN_COMM,&BASIN_NPROCS); 
  dum.get_gen_distribution_index(BASIN_ID, &iLo, &iHi);
  int* dataout=(int*)malloc(sizeof(int)*(iHi-iLo+1));

  int type=attr.get_data_type();

  if (type == BASIN_DATA_DOUBLE) {
    double* mydat=(double*)malloc(sizeof(double)*(iHi-iLo+1));
    dum.get(iLo,iHi,mydat);
    for (int i=0; i < iHi-iLo+1; i++) {
      dataout[i]=int(mydat[i]);
    }
    free(mydat);
  }
  else if (type == BASIN_DATA_INT) {
    int* mydat=(int*)malloc(sizeof(int)*(iHi-iLo+1));
    dum.get(iLo,iHi,mydat);
    for (int i=0; i < iHi-iLo+1; i++) {
      dataout[i]=int(mydat[i]);
    }
    free(mydat);
  } else if (type == BASIN_DATA_COMPLEX) {
    fftw_complex* mydat=(fftw_complex*)malloc(sizeof(fftw_complex)*(iHi-iLo+1));
    dum.get(iLo,iHi,mydat);
    for (int i=0; i < iHi-iLo+1; i++) {
      dataout[i]=int((mydat[i].re));
    }
    free(mydat);
  } 

  int idum=0;
  Attribute attr_out(attr.size(),idum);
  attr_out.put(iLo,iHi,dataout);
  MPI_Barrier(BASIN_COMM);

  free(dataout);
  return attr_out;
}


double min(Attribute &attr) {
  int iLo,iHi;
  int basin_id,basin_nprocs;
  MPI_Comm_size(MPI_COMM_WORLD,&basin_nprocs); 
  MPI_Comm_rank(MPI_COMM_WORLD,&basin_id);


  attr.get_gen_distribution_index(basin_id, &iLo, &iHi);
  
  int type=attr.get_data_type();
  if (type == BASIN_DATA_INT) {
    int* mydat=(int*)malloc(sizeof(int)*(iHi-iLo+1));
    attr.get(iLo,iHi,mydat);
    int minval=mydat[0],minval_red;
    for (int i=0 ; i < iHi-iLo+1; i++) {
      if (mydat[i] < minval) minval=mydat[i];
    }
    MPI_Allreduce(&minval,&minval_red,1,MPI_INT,MPI_MIN,BASIN_COMM);
    free(mydat);
    return(double(minval_red));
  } else if (type == BASIN_DATA_FLOAT) {
    float* mydat=(float*)malloc(sizeof(float)*(iHi-iLo+1));
    attr.get(iLo,iHi,mydat);
    float minval=mydat[0],minval_red;
    for (int i=0 ; i < iHi-iLo+1; i++) {
      if (mydat[i] < minval) minval=mydat[i];
    }
    MPI_Allreduce(&minval,&minval_red,1,MPI_FLOAT,MPI_MIN,BASIN_COMM);
    free(mydat);
    return(float(minval_red));
  } else if (type == BASIN_DATA_DOUBLE) {
    double* mydat=(double*)malloc(sizeof(double)*(iHi-iLo+1));
    attr.get(iLo,iHi,mydat);
    double minval=mydat[0],minval_red;
    for (int i=0 ; i < iHi-iLo+1; i++) {
      if (mydat[i] < minval) minval=mydat[i];
    }
    MPI_Allreduce(&minval,&minval_red,1,MPI_DOUBLE,MPI_MIN,BASIN_COMM);
    free(mydat);
    return(minval_red);
  } else {return(0.);}
}

double max(Attribute &attr) {
  int iLo,iHi;
  int basin_id,basin_nprocs;
  MPI_Comm_size(MPI_COMM_WORLD,&basin_nprocs); 
  MPI_Comm_rank(MPI_COMM_WORLD,&basin_id);

  attr.get_gen_distribution_index(basin_id, &iLo, &iHi);
  
  int type=attr.get_data_type();
  if (type == BASIN_DATA_INT) {
    int* mydat=(int*)malloc(sizeof(int)*(iHi-iLo+1));
    attr.get(iLo,iHi,mydat);
    int maxval=mydat[0],maxval_red;
    for (int i=0 ; i < iHi-iLo+1; i++) {
      if (mydat[i] > maxval) maxval=mydat[i];
    }
    MPI_Allreduce(&maxval,&maxval_red,1,MPI_INT,MPI_MAX,BASIN_COMM);
    free(mydat);
    return(double(maxval_red));
  } else if (type == BASIN_DATA_FLOAT) {
    float* mydat=(float*)malloc(sizeof(float)*(iHi-iLo+1));
    attr.get(iLo,iHi,mydat);
    float maxval=mydat[0],maxval_red;
    for (int i=0 ; i < iHi-iLo+1; i++) {
      if (mydat[i] > maxval) maxval=mydat[i];
    }
    MPI_Allreduce(&maxval,&maxval_red,1,MPI_FLOAT,MPI_MAX,BASIN_COMM);
    free(mydat);
    return(float(maxval_red));
  } else if (type == BASIN_DATA_DOUBLE) {
    double* mydat=(double*)malloc(sizeof(double)*(iHi-iLo+1));
    attr.get(iLo,iHi,mydat);
    double maxval=mydat[0],maxval_red;
    for (int i=0 ; i < iHi-iLo+1; i++) {
      if (mydat[i] > maxval) maxval=mydat[i];
    }
    MPI_Allreduce(&maxval,&maxval_red,1,MPI_DOUBLE,MPI_MAX,BASIN_COMM);
    free(mydat);
    return(maxval_red);
  } else {return(0.);}
}





BV1 sum(const Attribute& b)
{
      bv b_data;
      b.get_data(b_data);
      return boost::apply_visitor(Attribute_sum_visitor(),b_data);
}




Attribute operator+(int a, const Attribute &b)
{
  Attribute temp;
  bv_pod temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_plusII_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}


Attribute operator+(float a, const Attribute &b)
{
  Attribute temp;
  bv_pod temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_plusII_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}

Attribute operator+(double a, const Attribute &b)
{
  Attribute temp;
  bv_pod temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_plusII_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}

Attribute operator+(fftw_complex a, const Attribute &b)
{
  Attribute temp;
  bv1 temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_plusII_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}


#ifdef VECTOR23
Attribute operator+(Vector2 a, const Attribute &b)
{
  Attribute temp;
  bv_vec temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_plusII_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}
Attribute operator+(Vector3 a, const Attribute &b)
{
  Attribute temp;
  bv_vec temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_plusII_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}
#endif


Attribute operator-( int a, const Attribute &b) 
{
  Attribute temp;
  bv_pod temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_minus2_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}
Attribute operator-( float a, const Attribute &b) 
{
  Attribute temp;
  bv_pod temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_minus2_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}
Attribute operator-( double a, const Attribute &b) 
{
  Attribute temp;
  bv_pod temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_minus2_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}
Attribute operator-( fftw_complex a, const Attribute &b) 
{
  Attribute temp;
  bv1 temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_minus2_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}

#ifdef VECTOR23
Attribute operator-( Vector2 a, const Attribute &b) 
{
  Attribute temp;
  bv_vec temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_minus2_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}
Attribute operator-(Vector3 a, const Attribute &b) 
{
  Attribute temp;
  bv_vec temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_minus2_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}
#endif




Attribute operator*(int a, const Attribute &b)
{
  Attribute temp;
  bv_pod temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_times_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}


Attribute operator*(float a, const Attribute &b)
{
  Attribute temp;
  bv_pod temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_times_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}
Attribute operator*(double a, const Attribute &b)
{
  Attribute temp;
  bv_pod temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_times_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}
Attribute operator*(fftw_complex a, const Attribute &b)
{
  Attribute temp;
  bv1 temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_times_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}

#ifdef VECTOR23
Attribute operator*(Vector2 a, const Attribute &b)
{
  Attribute temp;
  bv_vec temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_times_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}

Attribute operator*(Vector3 a, const Attribute &b)
{
  Attribute temp;
  bv_vec temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_times_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}
#endif






Attribute operator/(int a, const Attribute &b)
{
  Attribute temp;
  bv_pod temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_divide2_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}
Attribute operator/(float a, const Attribute &b)
{
  Attribute temp;
  bv_pod temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_divide2_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}
Attribute operator/(double a, const Attribute &b)
{
  Attribute temp;
  bv_pod temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_divide2_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}
Attribute operator/(fftw_complex a, const Attribute &b)
{
  Attribute temp;
  bv1 temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_divide2_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}

#ifdef VECTOR23
Attribute operator/(Vector2 a, const Attribute &b)
{
  Attribute temp;
  bv_vec temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_divide2_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}
Attribute operator/(Vector3 a, const Attribute &b)
{
  Attribute temp;
  bv_vec temp2;
  bv b_data;
  b.get_data(b_data);
  temp2=a;
  temp.set_attribute(boost::apply_visitor(Attribute_divide2_visitor(),b_data,temp2));
  temp.set_context(b.get_context_pointer());
  return temp;
}
#endif

string Attribute::get_client_information (string info, string depth) {
	ostringstream stream;
	stream << info;
	stream << depth << "ATTRIBUTE:" << attribute_name << endl;
	vector <int> dims = get_dims ();
	stream << depth << "^DIMENSION:";
	stream << dims[0];
	for (unsigned int i = 1; i < dims.size (); ++i) {
		stream << "," << dims[i];
	}
	stream << endl;
	return stream.str ();
}

//NEW FUNCTIONS I HAVE TO WORK ON THE CONTEXT AND THE RETURN

Attribute attribute_index(int npts) {
  int basin_id,lo,hi;
  MPI_Comm_rank(BASIN_COMM,&basin_id);
  Attribute attr_out(npts,int(0));
  attr_out.get_gen_distribution_index(basin_id,&lo,&hi);
  int* mydat=(int*)malloc(sizeof(int)*(hi-lo+1));
  for (int i=0; i < hi-lo+1;i++) {
    mydat[i]=i+lo;
  }
  attr_out.put(lo,hi,mydat);
  free(mydat);

  
  return attr_out;
}

Attribute attribute_index(Attribute& attr, int dir) {
  vector<int> nx=attr.get_dims();
  int order_type=attr.get_context_pointer()->get_order_type();
  return attribute_index(nx,dir,order_type);
}

Attribute attribute_index(vector<int> nx, int dir, int order_type) {
  // Takes an input attribute, and generates an output
  // attribute (of type (double)) with elements equal to
  // out(i,j,k)=i OR j OR k, depending on the input "dir".
  // If attr is of type (FFT_HALF_HERMITIAN), then we know
  // that along the first Ndims-1 dimensions the elements
  // are sorted 0... Nx/2 ... -Nx/2+2... -1
  int basin_id,basin_nprocs;
  MPI_Comm_size(MPI_COMM_WORLD,&basin_nprocs); 
  MPI_Comm_rank(MPI_COMM_WORLD,&basin_id);
  int ndims=nx.size(); 
  vector<double>ll(ndims,0.),ur(ndims,0.);
  for (int i=0; i < ndims; i++) {ur[i]=nx[i]-1;}

  Context* c=new Context(ll,ur,nx,NULL);
  c->set_order_type(order_type);
  Attribute attr_out(nx,double(0.),"dum",c);
  int iLo, iHi,lorow,hirow;
  attr_out.get_gen_distribution_index(basin_id, &iLo, &iHi);
  attr_out.get_gen_distribution(basin_id,&lorow,&hirow);
  double* mydat=(double*)malloc(sizeof(double)*(iHi-iLo+1));
  
  int n,n0=0,nskip=1,nmod=1;
  if (dir == 1) {n0=lorow;}


  if (dir < ndims) 
    {
      for (int j=dir+1; j<= ndims; j++) 
	{
	  nskip=nskip*nx[j-1];
	}
    }
  nmod=nx[dir-1];


  int ishermite=0;
  if (order_type ==  FFT_HALF_HERMITIAN) {ishermite=1;}
  for (int i=0; i< iHi-iLo+1; i++) 
    {
      n=n0+(int(i/nskip) % nmod);
      if ((dir != ndims) && (n > nx[dir-1]/2)&& (ishermite==1)) {n=n-nx[dir-1];}
      mydat[i]=n;
    }
  
  attr_out.put(iLo,iHi,mydat);
  free(mydat);
  return attr_out;
}

Attribute recenter(Attribute& attr, vector<int> new_ll) {
  // Takes an attribute attr and recenters it at icenter.
  Attribute attr_out(attr.get_dims(),double(0.));
  vector<int> nx=attr.get_dims();
  int ndims=nx.size();
  int lorow,hirow,lo,hi,tlo,thi;
  vector<double> ll,ur;
  int data_type;

  int basin_id,basin_nprocs;
  MPI_Comm_size(MPI_COMM_WORLD,&basin_nprocs); 
  MPI_Comm_rank(MPI_COMM_WORLD,&basin_id);

  Context* c=attr.get_context_pointer();
  if (c != NULL) 
    {
      ll=c->get_LowerCorner();
      ur=c->get_UpperCorner(); 
    } 
  else 
    {
      for (int i=0; i < ndims; i++) 
	{
	  ll.push_back(0.);
	  ur.push_back(nx[i]);
	}
    }

  //ARE WE POTENTIALLY CHANGING THE PROPERTIES OF A GRID/LIST CONTEXT WITH THE LINES ABOVE or allowing an Attribute to have a Context different from that of its own Data?

  Context* cnew=new Context(ll,ur,nx,NULL);
  attr_out.set_context(cnew);

  for (int i=0; i < ndims; i++) 
    {
      double dx=(ur[i]-ll[i])*new_ll[i]/double(nx[i]);
      ur[i]-=dx;
      ll[i]-=dx;
    } 
  cnew->set_LowerCorner(ll);
  cnew->set_UpperCorner(ur);

  attr_out.get_gen_distribution_index(basin_id, &lo, &hi);
  attr_out.get_gen_distribution(basin_id,&lorow,&hirow);
  // We're going to need to get into specific types here. For now, assume 
  // double
  double *indat_double,*tmpdat_double;
  int *indat_int,*tmpdat_int;
  float *indat_float,*tmpdat_float;
  fftw_complex *indat_complex, *tmpdat_complex;
  data_type=attr.get_data_type();
  if (data_type == BASIN_DATA_INT) 
    {
      indat_int=(int*)malloc(sizeof(int)*(hi-lo+1));
      attr.get(lo,hi,indat_int);
    } 
  else if (data_type == BASIN_DATA_FLOAT) 
    {
      indat_float=(float*)malloc(sizeof(float)*(hi-lo+1));
      attr.get(lo,hi,indat_float);
    } 
  else if (data_type == BASIN_DATA_DOUBLE) 
    {
      indat_double=(double*)malloc(sizeof(double)*(hi-lo+1));
      attr.get(lo,hi,indat_double);
    } 
  else if (data_type == BASIN_DATA_COMPLEX) 
    {
      indat_complex=(fftw_complex*)malloc(sizeof(fftw_complex)*(hi-lo+1));
      attr.get(lo,hi,indat_complex);
      
    }
  else 
    {
      return attr;
    }
  // To figure out the components;
  vector<int>  n0(ndims,0),nskip(ndims,1);
  n0[0]=lorow;
  for (int i=0; i < ndims-1; i++) 
    {
      for (int j=i+1; j < ndims; j++) 
	{
	  nskip[i]=nskip[i]*nx[j];
	}
    }
  
  MPI_Barrier(BASIN_COMM);

  vector<int> id_current(ndims,0),id_target(ndims,0);
  
  for (int iter=0; iter < basin_nprocs; iter++) 
    {
      int target_node=((basin_id+iter) % basin_nprocs);
      attr_out.get_gen_distribution_index(target_node, &tlo, &thi);
      if (data_type == BASIN_DATA_INT) 
	{
	  tmpdat_int=(int*)malloc(sizeof(int)*(thi-tlo+1));
	  attr.get(tlo,thi,tmpdat_int);
	} 
      else if (data_type == BASIN_DATA_FLOAT) 
	{
	  tmpdat_float=(float*)malloc(sizeof(float)*(thi-tlo+1));
	  attr.get(tlo,thi,tmpdat_float);
	} 
      else if (data_type == BASIN_DATA_DOUBLE) 
	{
	  tmpdat_double=(double*)malloc(sizeof(double)*(thi-tlo+1));
	  attr.get(tlo,thi,tmpdat_double);
	} 
      else if (data_type == BASIN_DATA_COMPLEX) 
	{
	  tmpdat_complex=(fftw_complex*)malloc(sizeof(fftw_complex)*(thi-tlo+1));
	  attr.get(tlo,thi,tmpdat_complex);
	}
      for (int i=0; i < hi-lo+1; i++) 
	{
	  int id_out=0;
      
	  // Compute id_out
	  for (int idim=0; idim < ndims; idim++) 
	    {
	      id_current[idim]=n0[idim]+(int(i/nskip[idim]) % nx[idim]);
	      id_target[idim]=((id_current[idim]+new_ll[idim]) % nx[idim]);
	      id_out+=id_target[idim]*nskip[idim];
	    }
      
	  if ((id_out >= tlo)&&(id_out <= thi)) 
	    {
	      if (data_type == BASIN_DATA_INT) 
		{
		  tmpdat_int[id_out-tlo]=indat_int[i];
		} 
	      else if (data_type == BASIN_DATA_FLOAT) 
		{
		  tmpdat_float[id_out-tlo]=indat_float[i];
		} 
	      else if (data_type == BASIN_DATA_DOUBLE) 
		{
		  tmpdat_double[id_out-tlo]=indat_double[i];
		} 
	      else if (data_type == BASIN_DATA_COMPLEX) 
		{
		  tmpdat_complex[id_out-tlo]=indat_complex[i];
		}
	    }
	}
      if (data_type == BASIN_DATA_INT) 
	{
	  attr_out.put(tlo,thi,tmpdat_int);
	  free(tmpdat_int);
	} 
      else if (data_type == BASIN_DATA_FLOAT) 
	{
	  attr_out.put(tlo,thi,tmpdat_float);
	  free(tmpdat_float);
	} 
      else if (data_type == BASIN_DATA_DOUBLE) 
	{
	  attr_out.put(tlo,thi,tmpdat_double);
	  free(tmpdat_double);
	} 
      else if (data_type == BASIN_DATA_COMPLEX) 
	{
	  attr_out.put(tlo,thi,tmpdat_complex);
	  free(tmpdat_complex);
	}
      MPI_Barrier(BASIN_COMM);
    }
  if (data_type == BASIN_DATA_INT) 
    {
      free(indat_int);
    } 
  else if (data_type == BASIN_DATA_FLOAT) 
    {
      free(indat_float);
    } 
  else if (data_type == BASIN_DATA_DOUBLE) 
    {
      free(indat_double);
    } 
  else if (data_type == BASIN_DATA_COMPLEX) 
    {
      free(indat_complex);
    }
  return attr_out;
}

Attribute resort(Attribute& attr, Attribute& id) 
{
  int iLo1, iHi1,iLo2, iHi2;
  int nout=id.size();
  Attribute_Data_Type type=attr.get_data_type();
  Attribute attr_out;
  int *dataout_int,*mydat_int;
  float *dataout_float,*mydat_float;
  double *dataout_double,*mydat_double;
  fftw_complex *dataout_complex, *mydat_complex;
  int basin_id,basin_nprocs;
  MPI_Comm_size(MPI_COMM_WORLD,&basin_nprocs); 
  MPI_Comm_rank(MPI_COMM_WORLD,&basin_id);
  
  id.get_gen_distribution_index(basin_id, &iLo2, &iHi2);
  int* indices=(int*)malloc(sizeof(int)*(iHi2-iLo2+1));
  id.get(iLo2,iHi2,indices);
  if (type==BASIN_DATA_INT) 
    {
      attr_out=Attribute(nout,0);
      dataout_int=(int*)malloc(sizeof(int)*(iHi2-iLo2+1));
    } 
  else if (type == BASIN_DATA_FLOAT) 
    {
      attr_out=Attribute(nout,float(0.));
      dataout_float=(float*)malloc(sizeof(float)*(iHi2-iLo2+1));
    } 
  else if (type == BASIN_DATA_DOUBLE) 
    {
      attr_out=Attribute(nout,double(0.));
      dataout_double=(double*)malloc(sizeof(double)*(iHi2-iLo2+1));
    } 
  else if (type == BASIN_DATA_COMPLEX) 
    {
      fftw_complex dum;
      attr_out=Attribute(nout,dum);
      dataout_complex=(fftw_complex*)malloc(sizeof(fftw_complex)*(iHi2-iLo2+1));
    }
  // Now, iterate over all the processors...
  for (int id=0; id < basin_nprocs; id++) 
    {
      int iproc=basin_id+id;
      if (iproc >= basin_nprocs) {iproc=iproc-basin_nprocs;}
      attr.get_gen_distribution_index(iproc, &iLo1, &iHi1);
      if (type==BASIN_DATA_INT) 
	{
	  mydat_int=(int*)malloc(sizeof(int)*(iHi1-iLo1+1));
	  attr.get(iLo1,iHi1,(int*)mydat_int);
	  for (int i=0; i < iHi2-iLo2+1; i++) 
	    {
	      int index=indices[i];
	      if ((index >= iLo1)&&(index <=iHi1)) 
		{
		  dataout_int[i]=mydat_int[index-iLo1];
		}
	    }
	  free(mydat_int);
	} 
      else if (type == BASIN_DATA_FLOAT) 
	{
	  mydat_float=(float*)malloc(sizeof(float)*(iHi1-iLo1+1));
	  attr.get(iLo1,iHi1,(float*)mydat_float);
	  for (int i=0; i < iHi2-iLo2+1; i++) 
	    {
	      int index=indices[i];
	      if ((index >= iLo1)&&(index <=iHi1)) 
		{
		  dataout_float[i]=mydat_float[index-iLo1];
		}
	    }
	  free(mydat_float);
	} 
      else if (type == BASIN_DATA_DOUBLE) 
	{
	  mydat_double=(double*)malloc(sizeof(double)*(iHi1-iLo1+1));
	  attr.get(iLo1,iHi1,(double*)mydat_double);
	  for (int i=0; i < iHi2-iLo2+1; i++) 
	    {
	      int index=indices[i];
	      if ((index >= iLo1)&&(index <=iHi1)) 
		{
		  dataout_double[i]=mydat_double[index-iLo1];
		}
	    }
	  free(mydat_double);
	} 
      else if (type == BASIN_DATA_COMPLEX) 
	{
	  mydat_complex=(fftw_complex*)malloc(sizeof(fftw_complex)*(iHi1-iLo1+1));
	  attr.get(iLo1,iHi1,(fftw_complex*)mydat_complex);
	  for (int i=0; i < iHi2-iLo2+1; i++) 
	    {
	      int index=indices[i];
	      if ((index >= iLo1)&&(index <=iHi1)) 
		{
		  dataout_complex[i]=mydat_complex[index-iLo1];
		}
	    }
	  free(mydat_complex);
	}
    }
  if (type == BASIN_DATA_INT) 
    {
      attr_out.put(iLo2,iHi2,dataout_int);
      free(dataout_int);
    } 
  else if (type == BASIN_DATA_FLOAT) 
    {
      attr_out.put(iLo2,iHi2,dataout_float);
      free(dataout_float);
    } 
  else if (type == BASIN_DATA_DOUBLE) 
    {
      attr_out.put(iLo2,iHi2,dataout_double);
      free(dataout_double);
    } 
  else if (type == BASIN_DATA_COMPLEX) 
    {
      attr_out.put(iLo2,iHi2,dataout_complex);
      free(dataout_complex);
    }
  free(indices);
  attr_out.set_context(attr.get_context_pointer());
  return attr_out;
}


