#include "BASIN_IO.h"

BASIN_IO::BASIN_IO () { }

BASIN_IO::BASIN_IO (string fileName, Region* destination) {
	_data = destination;
	_fileName = fileName;
	MPI_Comm_rank(BASIN_COMM, &_myRank);
	bool status = ReadFile ();
	if (status) {
		if (_myRank == 0) cout << "Successfully read " << _fileName << '!' << endl;
	} else {
		if (_myRank == 0) cout << "Errors reading " << _fileName << '!' << endl;
	}
}

BASIN_IO::~BASIN_IO () { }

bool BASIN_IO::ReadFile () {
	if (!OpenFile ()) {
		if (_myRank == 0) cout << "Error during OpenFile ()" << endl;
		return false;
	}
	if (!ReadRegion ()) {
		if (_myRank == 0) cout << "Error during ReadRegion ()" << endl;
		return false;
	}
	if (!CloseFile ()) {
		if (_myRank == 0) cout << "Error during CloseFile ()" << endl;
		return false;
	}
	return true;
}

bool BASIN_IO::ReadRegion () {
	if (!GetDatasets ()) {
		if (_myRank == 0) cout << "Error during GetDatasets ()" << endl;
		return false;
	}
	while (NextDataset ()) {
		if (!MakeDataObjects ()) {
			if (_myRank == 0) cout << "Error during MakeDataObjects ()" << endl;
			return false;
		}
	}
	if (!GetGroups ()) {
		if (_myRank == 0) cout << "Error during GetGroups ()" << endl;
		return false;
	}
	while (NextGroup ()) {
		if (!MakeSubGroups ()) {
			if (_myRank == 0) cout << "Error during MakeSubGroups ()" << endl;
			return false;
		}
	}
	return true;
}

bool BASIN_IO::OpenFile () {
	if (_myRank == 0) cout << "Opening " << _fileName << "!!" << endl;
	return true;
}

bool BASIN_IO::CloseFile () {
	if (_myRank == 0) cout << "Closing " << _fileName << "!!" << endl;
	return true;
}

bool BASIN_IO::GetDatasets () {
	return true;
}

bool BASIN_IO::GetGroups () {
	return true;
}

bool BASIN_IO::NextDataset () {
	return true;
}

bool BASIN_IO::NextGroup () {
	return true;
}

bool BASIN_IO::MakeDataObjects () {
	return true;
}

bool BASIN_IO::MakeSubGroups () {
	return true;
}

bool BASIN_IO::SetUpperRight (vector<double> &ur) {
	unsigned int size = ur.size ();
	for (unsigned int i = 0; i < size; ++i) {
	}
}

bool BASIN_IO::SetLowerLeft (vector<double> &ll) {
	unsigned int size = ll.size ();
	for (unsigned int i = 0; i < size; ++i) {
	}
}


bool BASIN_IO::WriteFile () {
	if (!CreateFile ()) {
		if (_myRank == 0) cout << "Error during CreateFile ()" << endl;
		return false;
	}
	if (!WriteRegion ()) {
		if (_myRank == 0) cout << "Error during WriteRegion ()" << endl;
		return false;
	}
	if (!CloseWrittenFile ()) {
		if (_myRank == 0) cout << "Error during CloseFile ()" << endl;
		return false;
	}
	return true;
}

bool BASIN_IO::WriteRegion () {
	if (!WriteDatasets ()) {
		if (_myRank == 0) cout << "Error during WriteDatasets ()" << endl;
		return false;
	}
	if (!WriteSubGroups ()) {
		if (_myRank == 0) cout << "Error during WriteSubGroups ()" << endl;
		return false;
	}
	return true;
}

bool BASIN_IO::CreateFile () {
	return true;
}

bool BASIN_IO::CloseWrittenFile () {
	return true;
}

bool BASIN_IO::WriteDatasets () {
	return true;
}

bool BASIN_IO::WriteSubGroups () {
	return true;
}
