#include "basin_base.h"
#include "Data.h"
#include "Region.h"

// Put another comment here.
 
//*****************************************************************************
//  Begin with routines which are general to all Data structures
 
// We'll start with all of the constructors 
// General, empty initialization

Data::Data(Region* parent)  {
  myGeometry=Geometry(*( parent -> get_geometry()) );
  parentRegion = parent;
}

Data::Data() {parentRegion=NULL;}




//**************************************************************************
// General accessor functions
//
// Return the dimensionality of the underlying geometry
// 

// What are the properties of the grid (including their type)?



vector <string> Data::get_properties() {
  vector <string> outVals;
  
  for (map<string,Attribute>::const_iterator i = attributes.begin() ; 
       i != attributes.end(); i++ ) {
    outVals.push_back(i -> first);
  }
  return outVals;
}

int Data::delete_attribute(string key)
{
  attributes.erase(key);
  return 0;
}

bool Data::change_attribute_key (string oldkey, string newkey) {
	map <string, Attribute>::iterator iter = attributes.find (oldkey);
	if (iter != attributes.end ()) {
		attributes.insert (make_pair (newkey, iter->second));
		attributes[newkey].set_name_from_parent (newkey);
	} else {
		return false;
	}
	attributes.erase (iter->first);
	return true;
}
  
string Data::get_attribute_key_names (void) {
	string result = "";
	map <string, Attribute>::iterator iter;
	for (iter = attributes.begin (); iter != attributes.end (); ++iter) {
		result += iter->first + "\n";
	}
	return result;
}

Data::~Data(){}

string Data::get_client_information (string info, string depth) {
	map <string , Attribute>::iterator iter;
	for (iter = attributes.begin (); iter != attributes.end (); ++iter) {
		info = iter->second.get_client_information (info, depth + "^");
	}
	return info;
}

int Data::set_tag(string tagname, string tagtext) {
  tag[tagname]=tagtext;
  return 0;
}

int Data::delete_tag(string tagname) {
  tag.erase(tagname);
  return 0;
}

string Data::get_tag(string tagname) {
  return tag[tagname];
}

int Data::get_ntags() {
  return tag.size();
}

string Data::get_tagname(int i) {
  int k=0;
  for (map<string,string>::const_iterator j = tag.begin() ; 
       j != tag.end(); j++ ) {
    k++;
    if (i == k) {
      return(j -> first);
    }
  }
}
