#include "Geometry.h"


// A Geometry is defined by the the dimensionarlity (an int)
// the metric_type (cartesian, spherical, etc), the boundary type (periodic, or cartesian),
// and the limits of the coordinates...
Geometry::Geometry() {
  nDims=0;
  metricType=0;
  boundaryType=0;
  spaceType=0;
}

Geometry::Geometry(int nDimsNew,int metricTypeNew,int boundaryTypeNew,int spaceTypeNew,const vector<double>& llNew,
		   const vector<double>& urNew) {
  nDims=nDimsNew;
  metricType=metricTypeNew;
  boundaryType=boundaryTypeNew;
  spaceType=spaceTypeNew;
  ll=llNew;
  ur=urNew;
}


// Create a copy of an existing geometry
Geometry::Geometry(Geometry const &oldGeometry) {
  nDims=oldGeometry.nDims;
  metricType=oldGeometry.metricType;
  boundaryType=oldGeometry.boundaryType;
  spaceType=oldGeometry.spaceType;
  ll=oldGeometry.ll;
  ur=oldGeometry.ur;
}


//  returns the ll bound if the argument is 0, returns the upper right
// bound if the argument is 1
vector<double> Geometry::get_bound(int iSide) {
  if (iSide == 0) {
    return ll;
  }
  else {
    return ur;
  }
}

int Geometry::get_ndims() {
  return nDims;
}

//************************************************************
// Calculateulations within the geometry
//

// Find the distance between two points...
float Geometry::calculate_distance_squared(const vector<double>& x0,const vector<double>& x1){
  // right now, it doesn't check for either the boundary conditions
  // (periodicity) or the geometry type.  Too bad...
  float d2=0;
  for (int i=0; i < nDims; i++) {
    d2+=(x0[i]-x1[i])*(x0[i]-x1[i]);
  }
  return d2;
}

Geometry::~Geometry(){}
