#include "basin.h"
#include "stellardynamics.h"
#include "simple_plot.h"

int main( int argc, char *argv[] )
  {
    
    basin_initialize();

    int myRank;
    int isGrid;
    MPI_Comm_rank(BASIN_COMM, &myRank);

    vector<fftw_complex> temp(0);

    temp.resize(1);

    cerr << "temp[0] = " << temp[0] << endl;
    
    string filename = "starcluster.strlab";
    if(argc > 1)
      filename = argv[1];
    if(argc > 2)
      isGrid = atoi(argv[2]);
    
    Region stars(filename.c_str()); 
  
    if(isGrid == 3) {
      berr << "nlists = " << stars.get_nlists() << endl;
      //List *l = stars.get_list_pointer("RegionList0");
      //MPI_Barrier(BASIN_COMM);
      //berr << "TESTING" << endl;
      //Attribute x = l -> copy_attribute("STOP");
      //for(int i = 0; i < x.size(); i++)
      //berr << x[i] << endl;
    }
    
    if(isGrid == 2) {
      MPI_Barrier(BASIN_COMM);
      List *gd = stars.get_list_pointer("RegionList0");
      MPI_Barrier(BASIN_COMM);
      Attribute x = gd -> copy_attribute("var3");
      MPI_Barrier(BASIN_COMM);
      berr << "list size = " << x.size() << endl;
      MPI_Barrier(BASIN_COMM);
      //for(int i = 0; i < x.size(); i++)
      //berr << x[i] << endl;
    }
    
    else if(isGrid == 1) {
      berr << "nGrids = " << stars.get_ngrids() << endl;
      Grid *gd = stars.get_grid_pointer("RegionGrid0");
      Attribute x = gd -> copy_attribute("mass");
      berr << "size = " << x.size() << endl;
      for(int i = 0; i < x.size(); i++)
	berr << x[i] << endl;
    }

    else if(isGrid == 0) {
      berr << "nLists = " << stars.get_nlists() << endl;
      List *gd = stars.get_list_pointer("RegionList0");
      Attribute x = gd -> copy_attribute("mass");
      berr << "size = " << x.size() << endl;
      for(int i = 0; i < x.size(); i++)
	berr << x[i] << endl;
    }
    
    stars.SaveTEXT("out.dat");
    
    /*
    Attribute x = stars.copy_attribute("x");
    Attribute y = stars.copy_attribute("y");
    Attribute z = stars.copy_attribute("z");
    Attribute mass = stars.copy_attribute("m");
      


    Attribute density = density_list(x, y, z, mass);
    vector<double> center = density_center(x, y, z, density);
    
    berr << "The density center of this cluster is at "<<center[0] << " "<<center[1]<<" "<<center[2]<<endl;;


    vector<double> com = center_of_mass(x, y, z, mass);
    berr << "The center of mass of this cluster is at "<<com[0] << " "<<com[1]<<" "<<com[2]<<endl;;


    double core_rad = core_radius(x, y, z, density, center);
    berr <<"The core radius of this cluster is "<<core_rad << endl;

    vector<vector<double> > profiles;
    profiles=density_profile(x, y, z, mass, 10, 0.1, 10., "mn", "log");
      for(int j = 0; j < 10; j++)
	{
	bout << profiles[0][j] << " "<<profiles[1][j]<<" "<<profiles[2][j];
	bout << endl;
	}
    
    
    vector<double> lagrang_radii;
    vector<double> percentiles(3);
    percentiles[0]=0.1;
    percentiles[1]=0.5;
    percentiles[2]=0.9;
    lagrang_radii=lag_rad(x, y, z, mass,percentiles);

      for(int j = 0; j < 3; j++)
	{
	  bout << lagrang_radii[j] << " ";
	  bout << endl;
	}
    */
      
    basin_finalize();
    return( 0 );
  }
