#include <string>
#include <iostream>
#include <vector>
#include "Region.h"
#include "basin_base.h"

using namespace std;

class BASIN_IO {
	public:
		BASIN_IO ();
		BASIN_IO (string, Region*);
		virtual ~BASIN_IO ();
		bool ReadFile ();
		bool ReadRegion ();

		bool WriteFile ();
		bool WriteRegion ();

	protected:
		/* Input */
		virtual bool OpenFile ();
		virtual bool CloseFile ();
		virtual bool GetDatasets ();
		virtual bool GetGroups ();
		virtual bool NextDataset ();
		virtual bool NextGroup ();
		virtual bool MakeDataObjects ();
		virtual bool MakeSubGroups ();
		bool SetUpperRight (vector<double> &ur);
		bool SetLowerLeft (vector<double> &ll);

		/* Output */
		virtual bool CreateFile ();
		virtual bool CloseWrittenFile ();
		virtual bool WriteDatasets ();
		virtual bool WriteSubGroups ();
		

		/* The only data member,
		 * This is the BASIN Region that will
		 * be built up via ReadFile () */
		Region* _data;
		string _fileName;
		int _myRank;
};

#ifdef BASIN_HAVE_HDF5
#include "HDF5_IO.C"
#endif

#ifdef BASIN_HAVE_CFITSIO
#include "FITS_IO.C"
#endif

#include "TEXT_IO.C"

#include "BIN_IO.C"


// This needs to be BASIN-ized.
