#include <string>
#include <sstream>
#include <iostream>
#include <vector>
#include "Region.h"
#include "basin_base.h"
#include "fitsio.h"

using namespace std;

class FITS_IO: public BASIN_IO {
 public:
  FITS_IO (string, Region*);
  ~FITS_IO ();
 private:
  bool OpenFile ();
  bool CloseFile ();
  bool NextDataset ();
  bool MakeDataObjects ();
  int NumDimensions();
  unsigned long NumElements();
  int NumCols();
  void AttInfo (unsigned int nCols, vector<string> &colName, vector<int> &colType, 
		vector<int> &colRank1, vector<int> &colRank2);
  int ReadCol(int iLo, int iHi, int col, int nrows, char* tType[], int typeCode);
  bool NextGroup ();

  int _myRank;
  int _nProcs;
  List *_newList;
  Grid *_newGrid;

  string _fileName;

  unsigned long int _iList;
  unsigned long int _iGrid;

  int _numHDUs;
  int _hduCount;
  int _hduType;

  //unsigned int _nInts;
  //unsigned int _nDoubles;
  //unsigned int _nStrings;
  //unsigned int _nVec2ds;
  //unsigned int _nVec3ds; 
  //unsigned int _nFloats;

  string _doubleTypeKey;
  string _intTypeKey;
  string _stringTypeKey;
  string _floatTypeKey;
  string _complexTypeKey;
  //string _vec2TypeKey;
  //string _vec3TypeKey;
  string _addNameKey;

  string _delimiters;

  fitsfile *_filePtr;

  vector<int> _iArray;
  vector<double> _dArray;
  //vector<vector<char>*> _sArray;
  vector<float> _fArray;
#ifdef VECTOR23
  vector<Vector2> _vec2DArray;
  vector<Vector3> _vec3DArray;
#endif
  vector<fftw_complex> _complexArray;
};
