/*
  *  C++ core and functions for BASIN.
 *  Copyright (C) 2006  BASIN team
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

class matrix {
 public:
  matrix();
  matrix(int n, int m);
  matrix(int n); // Make a square identity matrix
  matrix(double *arr, int n, int m);
  matrix& operator+(matrix &);
  matrix& operator-(matrix &);
  matrix& operator*(matrix &);
  matrix& operator*(double);
  matrix& operator*(int);
  double& operator()(int index1, int index2);
  double& get_element(int i,int j);
  double* get_data();
  double* copy_data();
  int get_n();
  int get_m();
 private:
  int n,m;
  double *data;
};

matrix& matrix_invert(matrix &a);
matrix& matrix_mult(matrix& a, matrix& b);
matrix& operator*(double c,matrix& a);
matrix& operator*(int c, matrix& a);
