/* 
   THIS FILE CONTAINS ALL THE NECESSARY OPERATORS SPECIALIZATIONS
   
*/

//OPERATOR + START

template <>  template <> inline
ba< promote_trait<double,double>::T_promote> ba<double>::operator+ (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<double,double>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<double,float>::T_promote> ba<double>::operator+ (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<double,float>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba< promote_trait<double,int>::T_promote> ba<double>::operator+ (int y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<double,int>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<double,fftw_complex>::T_promote> ba<double>::operator+ (fftw_complex y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<double,fftw_complex>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<promote_trait<double,double>::T_promote> ba<double>::operator+(const ba<double> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
       promote_trait<double,double>::T_promote temp=this->g[i]+b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<promote_trait<double,float>::T_promote> ba<double>::operator+(const ba<float> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<double,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
       promote_trait<double,float>::T_promote temp=this->g[i]+b.ba_get_access(i); 
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<promote_trait<double,int>::T_promote> ba<double>::operator+(const ba<int> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<double,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
       promote_trait<double,int>::T_promote temp=this->g[i]+b.ba_get_access(i); 
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



template <> template <> inline
ba<promote_trait<double,fftw_complex>::T_promote> ba<double>::operator+(const ba<fftw_complex> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<double,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
       promote_trait<double,fftw_complex>::T_promote temp=this->g[i]+b.ba_get_access(i); 
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};




template <>  template <> inline
ba< promote_trait<float,float>::T_promote> ba<float>::operator+ (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<float,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<float,float>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}


template <>  template <> inline
ba< promote_trait<float,double>::T_promote> ba<float>::operator+ (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<float,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<float,double>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}



template <>  template <> inline
ba< promote_trait<float,int>::T_promote> ba<float>::operator+ (int y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<float,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<float,int>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<float,fftw_complex>::T_promote> ba<float>::operator+ (fftw_complex y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<float,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<float,fftw_complex>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}










template <> template <> inline
ba< promote_trait<float,double>::T_promote> ba<float>::operator+(const ba<double> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<float,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
      promote_trait<float,double>::T_promote temp=this->g[i]+b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



template <> template <> inline
ba<promote_trait<float,float>::T_promote> ba<float>::operator+(const ba<float> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<float,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
      promote_trait<float,float>::T_promote temp=this->g[i]+b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<float,int>::T_promote> ba<float>::operator+(const ba<int> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<float,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
      promote_trait<float,int>::T_promote temp=this->g[i]+b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<float,fftw_complex>::T_promote> ba<float>::operator+(const ba<fftw_complex> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<float,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
      promote_trait<float,fftw_complex>::T_promote temp=this->g[i]+b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};


//===================
template <>  template <> inline
ba< promote_trait<int,float>::T_promote> ba<int>::operator+ (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<int,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<int,float>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}


template <>  template <> inline
ba< promote_trait<int,double>::T_promote> ba<int>::operator+ (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<int,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<int,double>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}



template <>  template <> inline
ba< promote_trait<int,int>::T_promote> ba<int>::operator+ (int y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<int,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<int,int>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<int,fftw_complex>::T_promote> ba<int>::operator+ (fftw_complex y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<int,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<int,fftw_complex>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}



template <> template <> inline
ba< promote_trait<int,double>::T_promote> ba<int>::operator+(const ba<double> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<int,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
      promote_trait<int,double>::T_promote temp=this->g[i]+b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



template <> template <> inline
ba<promote_trait<int,float>::T_promote> ba<int>::operator+(const ba<float> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<int,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
      promote_trait<int,float>::T_promote temp=this->g[i]+b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<int,int>::T_promote> ba<int>::operator+(const ba<int> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<int,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
      promote_trait<int,int>::T_promote temp=this->g[i]+b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<int,fftw_complex>::T_promote> ba<int>::operator+(const ba<fftw_complex> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<int,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
      promote_trait<int,fftw_complex>::T_promote temp=this->g[i]+b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

//=====================

template <>  template <> inline
ba< promote_trait<fftw_complex,float>::T_promote> ba<fftw_complex>::operator+ (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<fftw_complex,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<fftw_complex,fftw_complex>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}


template <>  template <> inline
ba< promote_trait<fftw_complex,double>::T_promote> ba<fftw_complex>::operator+ (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<fftw_complex,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<fftw_complex,double>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}



template <>  template <> inline
ba< promote_trait<fftw_complex,int>::T_promote> ba<fftw_complex>::operator+ (int y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<fftw_complex,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<fftw_complex,int>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<fftw_complex,fftw_complex>::T_promote> ba<fftw_complex>::operator+ (fftw_complex y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<fftw_complex,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<fftw_complex,fftw_complex>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}


template <> template <> inline
ba< promote_trait<fftw_complex,double>::T_promote> ba<fftw_complex>::operator+(const ba<double> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<fftw_complex,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
      promote_trait<fftw_complex,double>::T_promote temp=this->g[i]+b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



template <> template <> inline
ba<promote_trait<fftw_complex,float>::T_promote> ba<fftw_complex>::operator+(const ba<float> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<fftw_complex,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
      promote_trait<fftw_complex,float>::T_promote temp=this->g[i]+b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<fftw_complex,int>::T_promote> ba<fftw_complex>::operator+(const ba<int> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<fftw_complex,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
      promote_trait<fftw_complex,int>::T_promote temp=this->g[i]+b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<fftw_complex,fftw_complex>::T_promote> ba<fftw_complex>::operator+(const ba<fftw_complex> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<fftw_complex,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
      promote_trait<fftw_complex,fftw_complex>::T_promote temp=this->g[i]+b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

//+++++++++++++++++++++++

//OPERATOR+ END


//OPERATOR- START

template <>  template <> inline
ba< promote_trait<double,double>::T_promote> ba<double>::operator- (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<double,double>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<double,float>::T_promote> ba<double>::operator- (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<double,float>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba< promote_trait<double,int>::T_promote> ba<double>::operator- (int y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<double,int>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<double,fftw_complex>::T_promote> ba<double>::operator- (fftw_complex y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<double,fftw_complex>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<promote_trait<double,double>::T_promote> ba<double>::operator-(const ba<double> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
       promote_trait<double,double>::T_promote temp=this->g[i]-b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<promote_trait<double,float>::T_promote> ba<double>::operator-(const ba<float> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<double,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
       promote_trait<double,float>::T_promote temp=this->g[i]-b.ba_get_access(i); 
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<promote_trait<double,int>::T_promote> ba<double>::operator-(const ba<int> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<double,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
       promote_trait<double,int>::T_promote temp=this->g[i]-b.ba_get_access(i); 
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



template <> template <> inline
ba<promote_trait<double,fftw_complex>::T_promote> ba<double>::operator-(const ba<fftw_complex> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<double,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
       promote_trait<double,fftw_complex>::T_promote temp=this->g[i]-b.ba_get_access(i); 
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};




template <>  template <> inline
ba< promote_trait<float,float>::T_promote> ba<float>::operator- (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<float,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<float,float>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}


template <>  template <> inline
ba< promote_trait<float,double>::T_promote> ba<float>::operator- (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<float,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<float,double>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}



template <>  template <> inline
ba< promote_trait<float,int>::T_promote> ba<float>::operator- (int y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<float,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<float,int>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<float,fftw_complex>::T_promote> ba<float>::operator- (fftw_complex y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<float,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<float,fftw_complex>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}










template <> template <> inline
ba< promote_trait<float,double>::T_promote> ba<float>::operator-(const ba<double> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<float,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<float,double>::T_promote temp=this->g[i]-b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



template <> template <> inline
ba<promote_trait<float,float>::T_promote> ba<float>::operator-(const ba<float> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<float,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<float,float>::T_promote temp=this->g[i]-b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<float,int>::T_promote> ba<float>::operator-(const ba<int> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<float,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<float,int>::T_promote temp=this->g[i]-b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<float,fftw_complex>::T_promote> ba<float>::operator-(const ba<fftw_complex> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<float,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<float,fftw_complex>::T_promote temp=this->g[i]-b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};


//===================
template <>  template <> inline
ba< promote_trait<int,float>::T_promote> ba<int>::operator- (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<int,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<int,float>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}


template <>  template <> inline
ba< promote_trait<int,double>::T_promote> ba<int>::operator- (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<int,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<int,double>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}



template <>  template <> inline
ba< promote_trait<int,int>::T_promote> ba<int>::operator- (int y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<int,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<int,int>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<int,fftw_complex>::T_promote> ba<int>::operator- (fftw_complex y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<int,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<int,fftw_complex>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}



template <> template <> inline
ba< promote_trait<int,double>::T_promote> ba<int>::operator-(const ba<double> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<int,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<int,double>::T_promote temp=this->g[i]-b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



template <> template <> inline
ba<promote_trait<int,float>::T_promote> ba<int>::operator-(const ba<float> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<int,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<int,float>::T_promote temp=this->g[i]-b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<int,int>::T_promote> ba<int>::operator-(const ba<int> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<int,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<int,int>::T_promote temp=this->g[i]-b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<int,fftw_complex>::T_promote> ba<int>::operator-(const ba<fftw_complex> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<int,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<int,fftw_complex>::T_promote temp=this->g[i]-b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

//=====================

template <>  template <> inline
ba< promote_trait<fftw_complex,float>::T_promote> ba<fftw_complex>::operator- (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<fftw_complex,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<fftw_complex,fftw_complex>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}


template <>  template <> inline
ba< promote_trait<fftw_complex,double>::T_promote> ba<fftw_complex>::operator- (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<fftw_complex,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<fftw_complex,double>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}



template <>  template <> inline
ba< promote_trait<fftw_complex,int>::T_promote> ba<fftw_complex>::operator- (int y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<fftw_complex,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<fftw_complex,int>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<fftw_complex,fftw_complex>::T_promote> ba<fftw_complex>::operator- (fftw_complex y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<fftw_complex,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<fftw_complex,fftw_complex>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}


template <> template <> inline
ba< promote_trait<fftw_complex,double>::T_promote> ba<fftw_complex>::operator-(const ba<double> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<fftw_complex,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<fftw_complex,double>::T_promote temp=this->g[i]-b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



template <> template <> inline
ba<promote_trait<fftw_complex,float>::T_promote> ba<fftw_complex>::operator-(const ba<float> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<fftw_complex,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<fftw_complex,float>::T_promote temp=this->g[i]-b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<fftw_complex,int>::T_promote> ba<fftw_complex>::operator-(const ba<int> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<fftw_complex,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<fftw_complex,int>::T_promote temp=this->g[i]-b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<fftw_complex,fftw_complex>::T_promote> ba<fftw_complex>::operator-(const ba<fftw_complex> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<fftw_complex,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<fftw_complex,fftw_complex>::T_promote temp=this->g[i]-b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

//+++++++++++++++++++++++

//OPERATOR- END


//operator* start

template <>  template <> inline
ba< promote_trait<double,double>::T_promote_pr> ba<double>::operator* (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,double>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<double,double>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<double,float>::T_promote_pr> ba<double>::operator* (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,float>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<double,float>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba< promote_trait<double,int>::T_promote_pr> ba<double>::operator* (int y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,int>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<double,int>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<double,fftw_complex>::T_promote_pr> ba<double>::operator* (fftw_complex y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,fftw_complex>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<double,fftw_complex>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<promote_trait<double,double>::T_promote_pr> ba<double>::operator*(const ba<double> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,double>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]*b.g[i];
       promote_trait<double,double>::T_promote_pr temp=this->g[i]*b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<promote_trait<double,float>::T_promote_pr> ba<double>::operator*(const ba<float> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<double,float>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]*b.g[i];
       promote_trait<double,float>::T_promote_pr temp=this->g[i]*b.ba_get_access(i); 
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<promote_trait<double,int>::T_promote_pr> ba<double>::operator*(const ba<int> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<double,int>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]*b.g[i];
       promote_trait<double,int>::T_promote_pr temp=this->g[i]*b.ba_get_access(i); 
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



template <> template <> inline
ba<promote_trait<double,fftw_complex>::T_promote_pr> ba<double>::operator*(const ba<fftw_complex> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<double,fftw_complex>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]*b.g[i];
       promote_trait<double,fftw_complex>::T_promote_pr temp=this->g[i]*b.ba_get_access(i); 
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};




template <>  template <> inline
ba< promote_trait<float,float>::T_promote_pr> ba<float>::operator* (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<float,float>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<float,float>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}


template <>  template <> inline
ba< promote_trait<float,double>::T_promote_pr> ba<float>::operator* (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<float,double>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<float,double>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}



template <>  template <> inline
ba< promote_trait<float,int>::T_promote_pr> ba<float>::operator* (int y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<float,int>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<float,int>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<float,fftw_complex>::T_promote_pr> ba<float>::operator* (fftw_complex y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<float,fftw_complex>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<float,fftw_complex>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}










template <> template <> inline
ba< promote_trait<float,double>::T_promote_pr> ba<float>::operator*(const ba<double> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<float,double>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]*b.g[i];
      promote_trait<float,double>::T_promote_pr temp=this->g[i]*b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



template <> template <> inline
ba<promote_trait<float,float>::T_promote_pr> ba<float>::operator*(const ba<float> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<float,float>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]*b.g[i];
      promote_trait<float,float>::T_promote_pr temp=this->g[i]*b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<float,int>::T_promote_pr> ba<float>::operator*(const ba<int> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<float,int>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]*b.g[i];
      promote_trait<float,int>::T_promote_pr temp=this->g[i]*b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<float,fftw_complex>::T_promote_pr> ba<float>::operator*(const ba<fftw_complex> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<float,fftw_complex>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]*b.g[i];
      promote_trait<float,fftw_complex>::T_promote_pr temp=this->g[i]*b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};


//===================
template <>  template <> inline
ba< promote_trait<int,float>::T_promote_pr> ba<int>::operator* (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<int,float>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<int,float>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}


template <>  template <> inline
ba< promote_trait<int,double>::T_promote_pr> ba<int>::operator* (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<int,double>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<int,double>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}



template <>  template <> inline
ba< promote_trait<int,int>::T_promote_pr> ba<int>::operator* (int y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<int,int>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<int,int>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<int,fftw_complex>::T_promote_pr> ba<int>::operator* (fftw_complex y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<int,fftw_complex>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<int,fftw_complex>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}



template <> template <> inline
ba< promote_trait<int,double>::T_promote_pr> ba<int>::operator*(const ba<double> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<int,double>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]*b.g[i];
      promote_trait<int,double>::T_promote_pr temp=this->g[i]*b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



template <> template <> inline
ba<promote_trait<int,float>::T_promote_pr> ba<int>::operator*(const ba<float> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<int,float>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]*b.g[i];
      promote_trait<int,float>::T_promote_pr temp=this->g[i]*b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<int,int>::T_promote_pr> ba<int>::operator*(const ba<int> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<int,int>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]*b.g[i];
      promote_trait<int,int>::T_promote_pr temp=this->g[i]*b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<int,fftw_complex>::T_promote_pr> ba<int>::operator*(const ba<fftw_complex> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<int,fftw_complex>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]*b.g[i];
      promote_trait<int,fftw_complex>::T_promote_pr temp=this->g[i]*b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

//=====================

template <>  template <> inline
ba< promote_trait<fftw_complex,float>::T_promote_pr> ba<fftw_complex>::operator* (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<fftw_complex,fftw_complex>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<fftw_complex,fftw_complex>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}


template <>  template <> inline
ba< promote_trait<fftw_complex,double>::T_promote_pr> ba<fftw_complex>::operator* (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<fftw_complex,double>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<fftw_complex,double>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}



template <>  template <> inline
ba< promote_trait<fftw_complex,int>::T_promote_pr> ba<fftw_complex>::operator* (int y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<fftw_complex,int>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<fftw_complex,int>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<fftw_complex,fftw_complex>::T_promote_pr> ba<fftw_complex>::operator* (fftw_complex y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<fftw_complex,fftw_complex>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<fftw_complex,fftw_complex>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}


template <> template <> inline
ba< promote_trait<fftw_complex,double>::T_promote_pr> ba<fftw_complex>::operator*(const ba<double> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<fftw_complex,double>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]*b.g[i];
      promote_trait<fftw_complex,double>::T_promote_pr temp=this->g[i]*b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



template <> template <> inline
ba<promote_trait<fftw_complex,float>::T_promote_pr> ba<fftw_complex>::operator*(const ba<float> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<fftw_complex,float>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]*b.g[i];
      promote_trait<fftw_complex,float>::T_promote_pr temp=this->g[i]*b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<fftw_complex,int>::T_promote_pr> ba<fftw_complex>::operator*(const ba<int> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<fftw_complex,int>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]*b.g[i];
      promote_trait<fftw_complex,int>::T_promote_pr temp=this->g[i]*b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<fftw_complex,fftw_complex>::T_promote_pr> ba<fftw_complex>::operator*(const ba<fftw_complex> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<fftw_complex,fftw_complex>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]*b.g[i];
      promote_trait<fftw_complex,fftw_complex>::T_promote_pr temp=this->g[i]*b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

//+++++++++++++++++++++++


//operator* end

//operator/ start

template <>  template <> inline
ba< promote_trait<double,double>::T_promote> ba<double>::operator/ (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<double,double>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<double,float>::T_promote> ba<double>::operator/ (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<double,float>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba< promote_trait<double,int>::T_promote> ba<double>::operator/ (int y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<double,int>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<double,fftw_complex>::T_promote> ba<double>::operator/ (fftw_complex y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<double,fftw_complex>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<promote_trait<double,double>::T_promote> ba<double>::operator/(const ba<double> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<double,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
       promote_trait<double,double>::T_promote temp=this->g[i]/b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<promote_trait<double,float>::T_promote> ba<double>::operator/(const ba<float> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<double,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
       promote_trait<double,float>::T_promote temp=this->g[i]/b.ba_get_access(i); 
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<promote_trait<double,int>::T_promote> ba<double>::operator/(const ba<int> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<double,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
       promote_trait<double,int>::T_promote temp=this->g[i]/b.ba_get_access(i); 
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



template <> template <> inline
ba<promote_trait<double,fftw_complex>::T_promote> ba<double>::operator/(const ba<fftw_complex> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<double,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
       promote_trait<double,fftw_complex>::T_promote temp=this->g[i]/b.ba_get_access(i); 
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};




template <>  template <> inline
ba< promote_trait<float,float>::T_promote> ba<float>::operator/ (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<float,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<float,float>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}


template <>  template <> inline
ba< promote_trait<float,double>::T_promote> ba<float>::operator/ (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<float,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<float,double>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}



template <>  template <> inline
ba< promote_trait<float,int>::T_promote> ba<float>::operator/ (int y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<float,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<float,int>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<float,fftw_complex>::T_promote> ba<float>::operator/ (fftw_complex y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<float,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<float,fftw_complex>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}










template <> template <> inline
ba< promote_trait<float,double>::T_promote> ba<float>::operator/(const ba<double> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<float,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<float,double>::T_promote temp=this->g[i]/b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



template <> template <> inline
ba<promote_trait<float,float>::T_promote> ba<float>::operator/(const ba<float> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<float,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<float,float>::T_promote temp=this->g[i]/b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<float,int>::T_promote> ba<float>::operator/(const ba<int> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<float,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<float,int>::T_promote temp=this->g[i]/b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<float,fftw_complex>::T_promote> ba<float>::operator/(const ba<fftw_complex> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<float,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<float,fftw_complex>::T_promote temp=this->g[i]/b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};


//===================
template <>  template <> inline
ba< promote_trait<int,float>::T_promote> ba<int>::operator/ (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<int,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<int,float>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}


template <>  template <> inline
ba< promote_trait<int,double>::T_promote> ba<int>::operator/ (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<int,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<int,double>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}



template <>  template <> inline
ba< promote_trait<int,int>::T_promote> ba<int>::operator/ (int y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<int,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<int,int>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<int,fftw_complex>::T_promote> ba<int>::operator/ (fftw_complex y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<int,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<int,fftw_complex>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}



template <> template <> inline
ba< promote_trait<int,double>::T_promote> ba<int>::operator/(const ba<double> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<int,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<int,double>::T_promote temp=this->g[i]/b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



template <> template <> inline
ba<promote_trait<int,float>::T_promote> ba<int>::operator/(const ba<float> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<int,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<int,float>::T_promote temp=this->g[i]/b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<int,int>::T_promote> ba<int>::operator/(const ba<int> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<int,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<int,int>::T_promote temp=this->g[i]/b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<int,fftw_complex>::T_promote> ba<int>::operator/(const ba<fftw_complex> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<int,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<int,fftw_complex>::T_promote temp=this->g[i]/b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

//=====================

template <>  template <> inline
ba< promote_trait<fftw_complex,float>::T_promote> ba<fftw_complex>::operator/ (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<fftw_complex,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<fftw_complex,fftw_complex>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}


template <>  template <> inline
ba< promote_trait<fftw_complex,double>::T_promote> ba<fftw_complex>::operator/ (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<fftw_complex,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<fftw_complex,double>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}



template <>  template <> inline
ba< promote_trait<fftw_complex,int>::T_promote> ba<fftw_complex>::operator/ (int y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<fftw_complex,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<fftw_complex,int>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<fftw_complex,fftw_complex>::T_promote> ba<fftw_complex>::operator/ (fftw_complex y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<fftw_complex,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<fftw_complex,fftw_complex>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
}


template <> template <> inline
ba< promote_trait<fftw_complex,double>::T_promote> ba<fftw_complex>::operator/(const ba<double> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<fftw_complex,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<fftw_complex,double>::T_promote temp=this->g[i]/b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



template <> template <> inline
ba<promote_trait<fftw_complex,float>::T_promote> ba<fftw_complex>::operator/(const ba<float> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<fftw_complex,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<fftw_complex,float>::T_promote temp=this->g[i]/b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<fftw_complex,int>::T_promote> ba<fftw_complex>::operator/(const ba<int> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<fftw_complex,int>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<fftw_complex,int>::T_promote temp=this->g[i]/b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba< promote_trait<fftw_complex,fftw_complex>::T_promote> ba<fftw_complex>::operator/(const ba<fftw_complex> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba<promote_trait<fftw_complex,fftw_complex>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]-b.g[i];
      promote_trait<fftw_complex,fftw_complex>::T_promote temp=this->g[i]/b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

//+++++++++++++++++++++++


//operator/ end




// VECTORS operators
#ifdef VECTOR23
template <>  template <> inline
ba< promote_trait<Vector3,double>::T_promote> ba<Vector3>::operator+ (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector3,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<Vector3,double>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}
/*
template <>  template <> inline
ba< promote_trait<Vector3,float>::T_promote> ba<Vector3>::operator+ (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector3,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<Vector3,float>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}
*/
template <> template <> inline
ba<promote_trait<Vector3,Vector3>::T_promote> ba<Vector3>::operator+(const ba<Vector3> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector3,Vector3>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
       promote_trait<Vector3,Vector3>::T_promote temp=this->g[i]+b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};


template <>  template <> inline
ba< promote_trait<Vector2,double>::T_promote> ba<Vector2>::operator+ (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector2,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<Vector2,double>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<Vector2,float>::T_promote> ba<Vector2>::operator+ (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector2,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<Vector2,float>::T_promote temp=y+this->g[i];
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<promote_trait<Vector2,Vector2>::T_promote> ba<Vector2>::operator+(const ba<Vector2> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector2,Vector2>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
       promote_trait<Vector2,Vector2>::T_promote temp=this->g[i]+b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



//===========-
template <>  template <> inline
ba< promote_trait<Vector3,double>::T_promote> ba<Vector3>::operator- (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector3,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<Vector3,double>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<Vector3,float>::T_promote> ba<Vector3>::operator- (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector3,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<Vector3,float>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<promote_trait<Vector3,Vector3>::T_promote> ba<Vector3>::operator-(const ba<Vector3> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector3,Vector3>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
       promote_trait<Vector3,Vector3>::T_promote temp=this->g[i]-b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};


template <>  template <> inline
ba< promote_trait<Vector2,double>::T_promote> ba<Vector2>::operator- (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector2,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<Vector2,double>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<Vector2,float>::T_promote> ba<Vector2>::operator- (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector2,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<Vector2,float>::T_promote temp=this->g[i]-y;
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<promote_trait<Vector2,Vector2>::T_promote> ba<Vector2>::operator-(const ba<Vector2> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector2,Vector2>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
       promote_trait<Vector2,Vector2>::T_promote temp=this->g[i]-b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

//==================

template <>  template <> inline
ba< promote_trait<Vector3,double>::T_promote_pr> ba<Vector3>::operator* (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector3,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<Vector3,double>::T_promote temp=y*this->g[i];
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}
/*=========
template <>  template <> inline
ba< promote_trait<Vector3,float>::T_promote> ba<Vector3>::operator* (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector3,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<Vector3,float>::T_promote temp=y*this->g[i];
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}
=======*/
template <> template <> inline
ba<promote_trait<Vector3,Vector3>::T_promote_pr> ba<Vector3>::operator*(const ba<Vector3> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector3,Vector3>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
       promote_trait<Vector3,Vector3>::T_promote_pr temp=this->g[i]*b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};


template <>  template <> inline
ba< promote_trait<Vector2,double>::T_promote_pr> ba<Vector2>::operator* (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector2,double>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<Vector2,double>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<Vector2,float>::T_promote_pr> ba<Vector2>::operator* (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector2,float>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<Vector2,float>::T_promote_pr temp=y*this->g[i];
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <> template <> inline
ba<promote_trait<Vector2,Vector2>::T_promote_pr> ba<Vector2>::operator*(const ba<Vector2> &b)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector2,Vector2>::T_promote_pr> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to add two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      //      T temp=this->g[i]+b.g[i];
       promote_trait<Vector2,Vector2>::T_promote_pr temp=this->g[i]*b.ba_get_access(i);
      //      local_ba.g[i]=temp;
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

//========================


template <>  template <> inline
ba< promote_trait<Vector3,double>::T_promote> ba<Vector3>::operator/ (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector3,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<Vector3,double>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<Vector3,float>::T_promote> ba<Vector3>::operator/ (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector3,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<Vector3,float>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}



template <>  template <> inline
ba< promote_trait<Vector2,double>::T_promote> ba<Vector2>::operator/ (double y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector2,double>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<Vector2,double>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba< promote_trait<Vector2,float>::T_promote> ba<Vector2>::operator/ (float y)
{
  //  ba<T> * local_ba =new ba<T>(const_cast<ba<T> &> (b)) ;
  ba< promote_trait<Vector2,float>::T_promote> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      promote_trait<Vector2,float>::T_promote temp=this->g[i]/y;
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}
#endif

//=====RELATIONAL OPERATORS============

//OPERATOR < START

template <>  template <> inline
ba<int> ba<double>::operator< (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<y);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<double>::operator< (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<double>::operator< (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<double>::operator<(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<double>::operator<(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<double>::operator<(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]<b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};
//+++++++++
template <>  template <> inline
ba<int> ba<float>::operator< (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<y);
      local_ba.ba_set(i,temp);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<float>::operator< (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<float>::operator< (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<float>::operator<(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<float>::operator<(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<float>::operator<(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]<b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



//+++++++++++++++++++++++

template <>  template <> inline
ba<int> ba<int>::operator< (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<y);
      local_ba.ba_set(i,temp);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<int>::operator< (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<int>::operator< (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<int>::operator<(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<int>::operator<(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<int>::operator<(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]<b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};


//OPERATOR< END


//OPERATOR > START

template <>  template <> inline
ba<int> ba<double>::operator> (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>y);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<double>::operator> (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<double>::operator> (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<double>::operator>(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<double>::operator>(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<double>::operator>(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]>b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};
//+++++++++
template <>  template <> inline
ba<int> ba<float>::operator> (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>y);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<float>::operator> (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<float>::operator> (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<float>::operator>(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<float>::operator>(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<float>::operator>(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]>b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



//+++++++++++++++++++++++

template <>  template <> inline
ba<int> ba<int>::operator> (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>y);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<int>::operator> (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<int>::operator> (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<int>::operator>(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<int>::operator>(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<int>::operator>(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]>b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};


//OPERATOR> END

//----------------
//OPERATOR >= START

template <>  template <> inline
ba<int> ba<double>::operator>= (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>=y);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<double>::operator>= (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<double>::operator>= (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<double>::operator>=(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>=b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<double>::operator>=(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<double>::operator>=(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]>=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};
//+++++++++
template <>  template <> inline
ba<int> ba<float>::operator>= (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>=y);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<float>::operator>= (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<float>::operator>= (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<float>::operator>=(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>=b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<float>::operator>=(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<float>::operator>=(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]>=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



//+++++++++++++++++++++++

template <>  template <> inline
ba<int> ba<int>::operator>= (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>=y);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<int>::operator>= (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<int>::operator>= (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<int>::operator>=(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>=b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<int>::operator>=(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]>=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<int>::operator>=(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]>=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};


//OPERATOR>= END
//-------------------------------------
//OPERATOR >= START

template <>  template <> inline
ba<int> ba<double>::operator<= (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<=y);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<double>::operator<= (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<double>::operator<= (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<double>::operator<=(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<=b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<double>::operator<=(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<double>::operator<=(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]<=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};
//+++++++++
template <>  template <> inline
ba<int> ba<float>::operator<= (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<=y);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<float>::operator<= (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<float>::operator<= (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<float>::operator<=(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<=b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<float>::operator<=(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<float>::operator<=(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]<=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



//+++++++++++++++++++++++

template <>  template <> inline
ba<int> ba<int>::operator<= (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<=y);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<int>::operator<= (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<int>::operator<= (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<int>::operator<=(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<=b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<int>::operator<=(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]<=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<int>::operator<=(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]<=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};


//OPERATOR<= END







//----------------
//OPERATOR== START

template <>  template <> inline
ba<int> ba<double>::operator== (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]==y);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<double>::operator== (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]==y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<double>::operator== (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]==y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<double>::operator==(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]==b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<double>::operator==(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]==b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<double>::operator==(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]==b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};
//+++++++++
template <>  template <> inline
ba<int> ba<float>::operator== (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]==y);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<float>::operator== (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]==y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<float>::operator== (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]==y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<float>::operator==(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]==b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<float>::operator==(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]==b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<float>::operator==(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]==b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



//+++++++++++++++++++++++

template <>  template <> inline
ba<int> ba<int>::operator== (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]==y);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<int>::operator== (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]==y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<int>::operator== (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]==y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<int>::operator==(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]==b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<int>::operator==(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]==b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<int>::operator==(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]==b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};


//OPERATOR== END

//------------------
//OPERATOR!= START

template <>  template <> inline
ba<int> ba<double>::operator!= (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]!=y);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<double>::operator!= (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]!=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<double>::operator!= (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]!=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<double>::operator!=(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]!=b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<double>::operator!=(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]!=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<double>::operator!=(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]!=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};
//+++++++++
template <>  template <> inline
ba<int> ba<float>::operator!= (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]!=y);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<float>::operator!= (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]!=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<float>::operator!= (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]!=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<float>::operator!=(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]!=b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<float>::operator!=(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]!=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<float>::operator!=(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]!=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};



//+++++++++++++++++++++++

template <>  template <> inline
ba<int> ba<int>::operator!= (int y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]!=y);
      local_ba.ba_set(i,temp);
      //      local_ba.g[i]=temp;
    }
  return local_ba;
}

template <>  template <> inline
ba<int> ba<int>::operator!= (float y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]!=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}


template <>  template <> inline
ba<int> ba<int>::operator!= (double y)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]!=y);
      local_ba.ba_set(i,temp);
    }
  return local_ba;
}

template <> template <> inline
ba<int> ba<int>::operator!=(const ba<double> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]!=b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<int>::operator!=(const ba<float> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]!=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};

template <> template <> inline
ba<int> ba<int>::operator!=(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to compare two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
       int temp=(this->g[i]!=b.ba_get_access(i)); 
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};


//OPERATOR!= END

template <> template <> inline
ba<int> ba<int>::operator&&(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to use AND with two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(this->g[i]*b.ba_get_access(i));
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};


template <> template <> inline
ba<int> ba<int>::operator||(const ba<int> &b)
{
  ba<int> local_ba;
  local_ba.ba_create(dimensions,comm,0);
  if (this->dimensions!=b.ba_get_dimensions())
    {
      cerr<<"Error: you are trying to use OR with two ba with different dimensions!"<<endl;
            return local_ba;
    }
  for (int i=0;i<(loc_dim_v)*(dim_v/dimensions[0]);i++)
    {
      int temp=(int)ceil(double((this->g[i]+b.ba_get_access(i)))/2.);
      local_ba.ba_set(i,temp);

    }
  return local_ba;
};
