#!/bin/bash

path=`pwd`

echo "Creating BASIN-config.sh..."
./build_BASIN-config.sh $path/include $path/lib $visit_dir
if [ ! -d ./bin ]; then
    echo "Creating bin directory..."
    mkdir bin
fi
mv BASIN-config $path/bin/

# Build an environment script for bash
echo "Building bash environment script..."
echo -e "export basin_bin=$path \n
export LD_LIBRARY_PATH=\$basin_bin/lib:\$LD_LIBRARY_PATH" > basin_env.sh

# Build an environment script for tcsh
echo "Building tcsh environment script..."
echo -e "setenv basin_bin $path \n
setenv LD_LIBRARY_PATH \$basin_bin/lib" > basin_env.csh

echo "Kernel install finished."

