#include "basin_package.h"
#include "statistics.h"

function::function() {
  type=0;
  order=2;
  ai.resize(order+1);
  ai[0]=0.;
}

function::function(int mytype, int myorder) {
  type=mytype;
  order=myorder;
  ai.resize(order+1);
  ai[0]=0.;
}

void function::set_order(int myorder) {
  order=myorder;
  ai.resize(order+1);
}

void function::set_type(int mytype) {
  type=mytype;
}

void function::set_coeffs(vector<double> coeffs) {
  ai=coeffs;
  order=coeffs.size()-1;
}

double function::eval(double x) {
  double y=0.;;
  if (type == 0) {
    for (int i=0; i <= order; i++) {
      y+=ai[i]*pow(x,i);
    }
  }
  return y;
}

vector<double> function::eval(vector<double> x) {
  vector<double> y(x.size(),0.);
  if (type == 0) {
    for (int i=0; i <= order; i++) {
      for (int j=0; j < x.size(); j++) {
	y[j]+=ai[i]*pow(x[j],i);
      }
    }
  }
  return y;
}
Attribute function::eval(Attribute& x) {
  Attribute y=x*0.;
  if (type == 0) {
    for (int i=0; i <= order; i++) {
      y=y+ai[i]*pow(x,i);
    }
  }
  return y;
}
