#include "basin_package.h"
#include "statistics.h"

vector<int> histogram(Attribute& attr, double binmin, double dbin, int nbins) {
  int myhist[nbins];
  int myhist_total[nbins];
  vector<int> outhist(nbins,0);
  int lo,hi,ibin;
  attr.get_gen_distribution_index(BASIN_ID,&lo,&hi);
  for (int i=0; i < nbins; i++) myhist[i]=0;
  for (int i=lo; i<= hi; i++) {
    if (double(attr[i]) > binmin) {
      ibin=int((double(attr[i])-binmin)/dbin);
      if ((ibin >=0 )&&(ibin < nbins)) myhist[ibin]++;
    }
  }
  // Now, combine all of them
  MPI_Reduce(myhist,myhist_total,nbins,MPI_INT,MPI_SUM,0,BASIN_COMM);
  for (int i=0; i < nbins; i++) outhist[i]=myhist_total[i];
  return outhist;
}
