#include "basin_package.h"
#include "transforms.h"

string xyz_to_equatorial (List* listptr, string x, string y, string z, string ra, string dec, string r) {
	if (listptr == NULL) {
		return "Bad list pointer";
	}
	string return_string;
	// Does the 1st string exist?
	Attribute *x_ptr;
	Attribute *y_ptr;
	Attribute *z_ptr;
	if (listptr-> attribute_exist (x)) {
		x_ptr = listptr-> get_attribute_pointer (x);
	} else {
		x_ptr = listptr-> get_attribute_pointer (0);
		return_string +=  x + " not found, default 0's\n";
	}
	if (listptr-> attribute_exist (y)) {
		y_ptr = listptr-> get_attribute_pointer (y);
	} else {
		y_ptr = listptr-> get_attribute_pointer (0);
		return_string += y + " not found, default 0's\n";
	}
	if (listptr-> attribute_exist (z)) {
		z_ptr = listptr-> get_attribute_pointer (z);
	} else {
		z_ptr = listptr-> get_attribute_pointer (0);
		return_string += z + " not found, default 0's\n";
	}

	Attribute raTemp = where ((*x_ptr) != 0, 57.3 * atan((*y_ptr) / (*x_ptr)), (*x_ptr) * 0);
	Attribute decTemp = where ((*x_ptr) != 0 && cos(raTemp / 57.3) != 0, 57.3 * atan((*z_ptr) / ((*x_ptr) * cos(raTemp / 57.3))), (*x_ptr) * 0);
	Attribute rTemp = where (sin(decTemp / 57.3) != 0, (*z_ptr) / sin(decTemp / 57.3), (*z_ptr) * 0);
	return_string += "Created " + r + ", " + dec + ", and " + ra + " attributes in list!";

	/* Adds the new calculated attributes
	 * into the existing List*/
	listptr-> add_attribute (r, rTemp);
	listptr-> add_attribute (dec, decTemp);
	listptr-> add_attribute (ra, raTemp);

	return return_string;
}


// This function should be deprecated.
string xyz_to_equatorial (Attribute* x, Attribute* y, Attribute* z, Attribute* raOut, Attribute* decOut, Attribute* rOut) {
	*raOut = where ((*x) != 0, 57.3 * atan((*y) / (*x)), (*x) * 0);
	*decOut = where ((*x) != 0 && cos((*raOut) / 57.3) != 0, 57.3 * atan((*z) / ((*x) * cos((*raOut) / 57.3))), (*x) * 0);
	*rOut = where (sin((*decOut) / 57.3) != 0, (*z) / sin((*decOut) / 57.3), (*z) * 0);

	return "Success";
}

